#property copyright "Copyright  2008, Group Three LLC"
#property link      ""

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 100.0
#property indicator_buffers 2
#property indicator_color1 MediumBlue
#property indicator_color2 Maroon

extern int KPeriod = 14;
extern int DPeriod = 3;
extern int Slowing = 5;
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
int gi_104 = 0;
int gi_108 = 0;

int init() {
   IndicatorBuffers(4);
   SetIndexBuffer(2, g_ibuf_96);
   SetIndexBuffer(3, g_ibuf_100);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(0, g_ibuf_88);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(1, g_ibuf_92);
   string ls_0 = "QSto(" + KPeriod + "," + DPeriod + "," + Slowing + ")";
   IndicatorShortName(ls_0);
   SetIndexLabel(0, ls_0);
   SetIndexLabel(1, "Signal");
   gi_104 = KPeriod + Slowing;
   gi_108 = gi_104 + DPeriod;
   SetIndexDrawBegin(0, gi_104);
   SetIndexDrawBegin(1, gi_108);
   return (0);
}

int start() {
   double ld_12;
   double ld_20;
   double ld_28;
   double ld_36;
   double ld_44;
   int li_8 = IndicatorCounted();
   if (Bars <= gi_108) return (0);
   if (li_8 < 1) {
      for (int li_0 = 1; li_0 <= gi_104; li_0++) g_ibuf_88[Bars - li_0] = 0;
      for (li_0 = 1; li_0 <= gi_108; li_0++) g_ibuf_92[Bars - li_0] = 0;
   }
   li_0 = Bars - KPeriod;
   if (li_8 > KPeriod) li_0 = Bars - li_8 - 1;
   while (li_0 >= 0) {
      ld_20 = 1000000;
      for (int li_4 = li_0 + KPeriod - 1; li_4 >= li_0; li_4--) {
         ld_12 = Low[li_4 + 1];
         if (ld_20 > ld_12) ld_20 = ld_12;
      }
      g_ibuf_100[li_0] = ld_20;
      li_0--;
   }
   li_0 = Bars - KPeriod;
   if (li_8 > KPeriod) li_0 = Bars - li_8 - 1;
   while (li_0 >= 0) {
      ld_28 = -1000000;
      for (li_4 = li_0 + KPeriod - 1; li_4 >= li_0; li_4--) {
         ld_12 = High[li_4 + 1];
         if (ld_28 < ld_12) ld_28 = ld_12;
      }
      g_ibuf_96[li_0] = ld_28;
      li_0--;
   }
   li_0 = Bars - gi_104;
   if (li_8 > gi_104) li_0 = Bars - li_8 - 1;
   while (li_0 >= 0) {
      ld_36 = 0.0;
      ld_44 = 0.0;
      for (li_4 = li_0 + Slowing - 1; li_4 >= li_0; li_4--) {
         ld_36 += Open[li_4] - g_ibuf_100[li_4];
         ld_44 += g_ibuf_96[li_4] - g_ibuf_100[li_4];
      }
      if (ld_44 == 0.0) g_ibuf_88[li_0] = 100.0;
      else g_ibuf_88[li_0] = 100.0 * (ld_36 / ld_44);
      li_0--;
   }
   if (li_8 > 0) li_8--;
   int li_52 = Bars - li_8;
   for (li_0 = 0; li_0 < li_52; li_0++) g_ibuf_92[li_0] = iMAOnArray(g_ibuf_88, Bars, DPeriod, 0, MODE_SMA, li_0);
   return (0);
}